#ifndef SD_H
#define SD_H

/*******************************************************\
 * Definitii pentru parametrizarea bibliotecii	       *
\*******************************************************/

/* Comenzi pentru MMC/SDC */
#define CMD0		(0x40+0)	/* GO_IDLE_STATE */
#define CMD1		(0x40+1)	/* SEND_OP_COND (MMC) */
#define	ACMD41		(0xC0+41)	/* SEND_OP_COND (SDC) */
#define CMD8		(0x40+8)	/* SEND_IF_COND */
#define CMD16		(0x40+16)	/* SET_BLOCKLEN */
#define CMD17		(0x40+17)	/* READ_SINGLE_BLOCK */
#define CMD24		(0x40+24)	/* WRITE_BLOCK */
#define CMD55		(0x40+55)	/* APP_CMD */
#define CMD58		(0x40+58)	/* READ_OCR */

/* Configurarea SPI */
#define SPI_PORT	PORTB
#define SPI_DDR		DDRB
#define SPI_MISO	6
#define SPI_MOSI	5
#define SPI_SCK		7

/* Definitii accesul SPI la cardul SD */
#define SD_PORT		PORTB
#define SD_DDR		DDRB
#define SD_CS		4

/* Controlul portului */
#define SD_SELECT()	SD_PORT &= ~(1<<SD_CS)	/* SD CS = 0 */
#define SD_DESELECT()	SD_PORT |=  (1<<SD_CS)	/* SD CS = 1 */ 
#define	SD_SELECTED()	!(SPI_PORT &  0x10)	/* SD CS status (1 = selectat; 0 = deselectat) */

#define SPI_DELAY()	__builtin_avr_delay_cycles(2500 / (1000000000/F_CPU))

/*******************************************************\
 * Functii pentru utilizarea cardului SD	       *
\*******************************************************/
DSTATUS disk_initialize(void);
DRESULT disk_readp(BYTE *buf, DWORD lba, WORD offset, WORD cnt);
DRESULT disk_writep(const BYTE *buf, DWORD sa);

#endif // SD_H
